<?php

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

// El siguiente script se encarga de comprobar que los datos
// de un formulario son validos antes de enviarlos.
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.crr_form.crrID.value == ''  ||
       document.crr_form.crrID.value.search(/[^a-z,A-Z,0-9,\.,_,\@,\/,\-]/i) >= 0)
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', numeros y signos\'/\', \'.\', \'-\' y \'_\'');
    document.crr_form.crrID.focus();
    return false;
  }
  document.crr_form.submit();
  return true;
}
// -->
</script>\n";

// En la variable command guardaremos el estado de la revocacion.
// Dependiendo de su valor, entraremos en una u otra parte del codigo.
$command = $_POST["crr_command"];
$errorCode = "a0";
$status = "revoke";

switch($command) {
   
   // Por defecto mostramos el formulario en el que se le solicita
   // al usuario los datos del certificado a revocar   
   default:
      echo "<h1>Solicitud de Revocaci&oacute;n de Certificado</h1>
      <div id='tbox'>
         <h3 class='head_a2b1'>Datos de la Solicitud</h3>
            <div id='tbox_data_a1'>
               <form method='post' action='crr.php' enctype='multipart/form-data' name='crr_form'>
               <input type='hidden' name='crr_command' value='crr_process'>
               <div id='trow'>
                  <div id='tname'>Identificador</div>
                  <div id='tvalue'><input class='form_input' type='text' name='crrID'  size='25' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>C&oacute;digo de solicitud</div>
                  <div id='tvalue'><input class='cajaTexto' type='text' name='copa'  size='16' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>Password de Usuario</div>
                  <div id='tvalue'><input class='cajaTexto' type='password' name='userPass'  size='16' /></div>
               </div>
               <div id='trow'>
                  <div id='tname'>Motivo de la revocaci&oacute;n</div>
                  <div id='tvalue'><select name='revReason'>";
                  while (list (,$content) = each ($revReasons)) {
                     echo "<option>$content</option>";
                  }
                  echo "</select>
                  </div>
               </div>
               <div id='trow'>
                  <div id='tname'>Comentarios</div>
                  <div id='tvalue'><input type='text' name='comments'  size='25'></div>
               </div>
               <div id='trow'>
                  <div id='tvalue'>
                     <input class='button' type='button' value='Continuar' onclick='submit_form()' />
                  </div>
               </div>
               </form>
            </div> <!-- tbox_data_a1 -->
         </div> <!-- tbox -->\n";

      break;

      
   case "crr_process":
      // Obtenemos el valor de las variables pasadas en el formulario
      $copa = $_POST['copa'];
      $crrID = $_POST['crrID'];
      $revReason = $_POST['revReason'];
      $comments = $_POST['comments'];

      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array("cn", "sn", "pkirisID");
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
      if ( !$result )
	 $errorCode = "a4b1c3d1e1";
      
      // Verificamos si existe el codigo del certificado, si el 
      // resultado del count($result) es 1 no existe, si es 2 si existe.
      else if (count($result) == 1) 	   
	 $errorCode = "a4b1c3d2e1";
      // Si existe, tenemos que comprobar si el identificador introducido se corresponde con ese codigo
      else {  
	 if ($result[0]["pkirisid"][0] != $crrID )
	    $errorCode = "a4b1c3d2e2";
         else {
	          
            // Buscamos la informacion del certificado que tenga el usuario
	    // en estado 'issued'
            $filter2 = "(&(objectClass=pkirisCertificate)(pkirisStatus=issued)(pkirisCopaID=$copa))";
            $justthese = array("dn", "pkiriscerttype", "pkirispin");
  
            $result2 = ldap_get_info($ldapVar['base'], $filter2, $justthese);
     	    if ( !$result )
	       $errorCode = "a4b1c3d1e1";
            else if (count($result2) == 1) 
	       $errorCode = "a4b1c3d2e3";
            else {
               // Obtenemos el Certificado del usuario, lo pasamos a un archivo
	       // como .der y luego lo pasamos a .txt
               $userCert = ldap_get_cert($ldapVar['base'], $filter2);
	       // Si ha habido algun error, mostramos mensaje y no continuamos
               if (!$userCert)
		  $errorCode = "a4b1c3d1e5";
	       else {
	          list ($userCopa, $kk) = split ("c", $copa);
  	          $filter = "(&(objectClass=pkirisEndEntity)(pkirisCopaID=$userCopa))";
 	          $justthese = array("cn", "sn");
  	          $result3 = ldap_get_info($ldapVar['base'], $filter, $justthese);
		  if ( !$result3 )
		     $errorCode = "a4b1c3d1e1";
		  else {
   	             $cn = $result3[0]["cn"][0];
                     $sn = $result3[0]["sn"][0];
                     $type = $result2[0]["pkiriscerttype"][0];
                     $dn = $result2[0]["dn"];
  
                     echo "<h3>Datos sobre la solicitud de Revocaci&oacute;n (CRR)</h3>
                     <br />
                     <table border='1' cellpadding='2' cellspacing='0'>
                     <tr><td>Identificador</td><td>$crrID</td></tr>
                     <tr><td>C&oacute;digo de solicitud</td><td>$copa</td></tr>
                     <tr><td>Nombre</td><td>" . $cn . " " . $sn ."</td></tr>";
 
                     if ($type == "srv") 
                        echo "<tr><td>Tipo</td><td>Certificado de Servidor</td></tr>";
                     else 
                        echo "<tr><td>Tipo</td><td>Certificado de Usuario</td></tr>";
                     
                     echo "</table>
                     <br />
                     <h3>Datos sobre el certificado que se va a revocar</h3> 
                     <PRE>\n";

                     $derFile = $dirVar['crt'] . $copa.".x509ee";
                     // Verificamos si existe el fichero y si no lo creamos y volcamos la info del certificado en el
                     if (!file_exists($filename)) {
                        $der = fopen($derFile, "w");
                        fputs($der, $userCert[0]);
                        fclose($der);
                     }

                     $txtCert = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $result);
         
                     for($i = 1; $i < count($result); $i++) 
                        echo "$result[$i]\n"; 
                  
		      echo "</PRE>
                         <form method='post' action='crr.php'>
                         <input class='form_submit' type=submit value='Generar petici&oacute;n de revocaci&oacute;n'>
		         <input type='hidden' name='copa' value='$copa'>
                         <input type='hidden' name='dn' value='$dn'>
           	         <input type='hidden' name='errorCode'  value='$errorCode'>
   	   	         <input type='hidden' name='comments'  value='$comments'>
		         <input type='hidden' name='crr_reason' value='$revReason'>
                         <input type='hidden' name='crr_command' value='crr_makeXml'>
                         </form>\n";
		        
	          }
               }
	    }
         }
      }  
      break;

   case "crr_makeXml":
      $copa = $_POST['copa'];
      $dn = $_POST['dn'];
      $errorCode = $_POST['errorCode'];
      $crr_reason = $_POST['crr_reason'];
      $comments = $_POST['comments'];

      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
	 $errorCode = "a4b1c3d2e4";      
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza y el mismo xml al recargar el navegador
      else if ($lastStatus != "issued")
         $errorCode = "a4b1c3d2e7";
      else {
         $currentDate = date("YmdHis");
         $invalidityDate = $currentDate; // En un futuro, esta variable debe tener otro valor
	    
         $traceVals["status"] = $status;
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
         $traceVals["invalidityDate"] = $invalidityDate;
         $traceVals["revocationReason"] = $crr_reason;
         $traceVals["comments"] = $comments;
     
         // Construimos la urn con los valores especificados en $traceVals
         $pkiTrace =  getTrace ($traceVals);
	 if ( !$pkiTrace )
	    $errorCode = "a4b1c3d2e2";
	 else {
   	    // Necesitamos saber el numero copa del administrador de la RA para
	    // meterlo en el fichero XML y saber quien solicito la revocacion
            $subjectDN = getDn();
            if ( !$subjectDN )
	       $errorCode = "MIRAR";
	    else {
 	       #$adminCopa = getUserCopaFromDN($subjectDN);
               $adminCopa = "a0b1";
            
	       // Cambiamos los estados de pkiStatus, pkiDate y pkiRevocationReason
               $updateFields["pkirisstatus"] = $status;
               $updateFields["pkirisdate"] = $currentDate;
               $updateFields["pkirisrevocationreason"] = $crr_reason;
	       $updateFields["pkirisrevokedbycopaid"] = $adminCopa;
	 
               $r=ldap_mod_info($dn, $updateFields);
               if (!$r)
                  $errorCode = "a4b1c3d1e3";
	       else {
	          // Insertamos la traza en ldap
      	          $urn["pkiristrace"] = $pkiTrace;
	          $r=ldap_mod_add_info($dn, $urn);
  	          if (!$r) 
                     $errorCode = "a4b1c3d1e4";
	          else {
                     // Si no ha habido errores, generarmos el fichero XML para enviar los
                     // datos a la CA
                     $r = createXML ( array($copa) );
                     if (!$r) 
                        $errorCode = "a4b1c3d2e6";
                     else {
 			echo "<h1 class='title'>Solicitud de Revocaci&oacute;n</h1><h3> Solicitud Aceptada </h3>
                              <p> Su solicitud de revocaci&oacute;n ha sido aceptada y sera enviada de inmediato al administrador de la CA para revocar el certificado indicado.</p>\n";
                        // Escribimos en el fichero de log los cambios de estado realizados
 			$pkiLog['status'] = $status;
	                $pkiLog['eee'] = $copa;
         		$pkiLog['user'] = "RAadmin";
		        $pkiLog['error'] = $errorCode;
                        writeLog ($pkiLog);
                     }
                  }
               }
	    }
	 }
      }

     
      break;   
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error en la Solicitud de Revocaci&oacute;n </h2>
         <p> No ha sido posible generar su solicitud.</p>\n";

   $pkiLog['status'] = $status;
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "RAadmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
